=== modified file 'bzrlib/upgrade.py'
--- bzrlib/upgrade.py	2010-12-04 17:34:56 +0000
+++ bzrlib/upgrade.py	2010-12-04 17:58:25 +0000
@@ -225,12 +225,17 @@
     """
     succeeded = []
     exceptions = []
+    child_pb = ui.ui_factory.nested_progress_bar()
+    i = 0
+    child_pb.update('Upgrading bzrdirs', i, len(items))
     for control_dir in items:
+        i += 1
         # Do the conversion
         location = control_dir.root_transport.base
         bzr_object, bzr_label = control_dir._get_object_and_label()
+        type_label = label or bzr_label
+        child_pb.update("Upgrading %s" % (type_label), i, len(items))
         if verbose:
-            type_label = label or bzr_label
             note("Upgrading %s %s ...", type_label, location)
         try:
             if not dry_run:
@@ -252,6 +257,8 @@
                     (location, ex))
                 exceptions.append(ex)
 
+    child_pb.finished()
+
     # Return the result
     return succeeded, exceptions
 

